#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityNationalDayDrawLottery.h"
std::auto_ptr<M_ActivityNationalDayDrawLottery> M_ActivityNationalDayDrawLottery::msSingleton(nullptr);

int M_ActivityNationalDayDrawLottery::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityNationalDayDrawLotteryData* M_ActivityNationalDayDrawLottery::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityNationalDayDrawLotteryData>& M_ActivityNationalDayDrawLottery::GetMapData()
{
	return mMapData;
}

void M_ActivityNationalDayDrawLottery::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityNationalDayDrawLottery.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityNationalDayDrawLotteryData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		{
			const char* ItemId = element->Attribute("ItemId");
			std::vector<std::string> vecItemId;
			boost::split(vecItemId, ItemId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemId[i].c_str(), &temp))
				{
					data.mItemId.push_back(temp);
				}
			}
		}
		{
			const char* Number = element->Attribute("Number");
			std::vector<std::string> vecNumber;
			boost::split(vecNumber, Number, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecNumber.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecNumber[i].c_str(), &temp))
				{
					data.mNumber.push_back(temp);
				}
			}
		}
		data.mWeight = element->IntAttribute("Weight");
		data.mDisplayLabel = element->IntAttribute("DisplayLabel");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityNationalDayDrawLottery Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityNationalDayDrawLottery::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityNationalDayDrawLottery");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityNationalDayDrawLottery");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityNationalDayDrawLotteryData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readVectorInt(L, "ItemId", data.mItemId);
		LuaCfgHelper::readVectorInt(L, "Number", data.mNumber);
		LuaCfgHelper::readInt(L, "Weight", data.mWeight);
		LuaCfgHelper::readInt(L, "DisplayLabel", data.mDisplayLabel);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityNationalDayDrawLottery Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityNationalDayDrawLottery::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityNationalDayDrawLottery* M_ActivityNationalDayDrawLottery::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityNationalDayDrawLottery());
	}
	return msSingleton.get();
}

void M_ActivityNationalDayDrawLottery::Release()
{
	msSingleton.reset(nullptr);
}
